--load lib functions we use
local MachSkinCheck = MachAddon.MachSkinCheck

--This function checks if the player as an electric shield
--If they do, they lose overcharge over time.
local function ElectricShield(p)
	if leveltime % 3 == 0 and MachSkinCheck(p) and
	(p.powers[pw_shield] & SH_PROTECTELECTRIC > 0) then
		if p.machvars.staticCharge < 600 then
			p.machvars.staticCharge = $ + 1
		elseif p.machvars.staticCharge > 600 and not p.machvars.isBoosting then
			p.machvars.staticCharge = $ - 1
		end
	end
end

--Hooks
addHook("ThinkFrame", do
	for p in players.iterate do
		ElectricShield(p)
	end
end)