--to do:
--Set up thinkframe for auto

MachAddon.IsMachBalanced = 2 --1 = On, 2 = off
local balanceCheck = 3

--which flags do we check for competitive mode?
local compFlags = {
	[GT_COMPETITION] = true,
	[GT_RACE] = true,
	[GT_MATCH] = true,
	[GT_TEAMMATCH] = true,
	[GT_TAG] = true,
	[GT_HIDEANDSEEK] = true,
	[GT_CTF] = true
}

local machBalOptns = {
	[1] = "ON",
	[2] = "OFF",
	[3] = "AUTO"
}

local machArgOptns = {
	["ON"] = 1,
	["OFF"] = 2,
	["AUTO"] = 3
}


--this function handles the changing of balance mode
local function AutoBalance(mapnum)
	if balanceCheck == 1
	or (balanceCheck == 3 and compFlags[gametype]) then
		MachAddon.IsMachBalanced = 1
	else
		MachAddon.IsMachBalanced = 2
	end
	--print(balanceCheck .. " " .. MachAddon.IsMachBalanced)
end


local function MachBalance(p, arg)
	if arg ~= nil then
		arg = string.upper(arg)
	end
	
	if machArgOptns[arg] then
		balanceCheck = machArgOptns[arg]
		AutoBalance(gamemap)
		CONS_Printf(p, "Mach Balance has been set to " .. machBalOptns[balanceCheck] .. "!")
	else
		CONS_Printf(p, "===================")
		CONS_Printf(p, "mach_balancemode <AUTO/ON/OFF>")
		CONS_Printf(p, "")
		CONS_Printf(p, "AUTO: Balance mode is enabled for competitive gamemodes only.")
		CONS_Printf(p, "ON: Balance mode is always on, ensuring Mach is weaker.")
		CONS_Printf(p, "OFF:  Balance mode is off, there is no hope.")
		CONS_Printf(p, "")
		CONS_Printf(p, "Current balance mode: " .. machBalOptns[balanceCheck])
		CONS_Printf(p, "===================")
	end
end


COM_AddCommand("mach_balancemode", MachBalance, COM_ADMIN)


--this hook syncs the balance variables
addHook("NetVars", function(net)
	balanceCheck = net(balanceCheck)
	MachAddon.IsMachBalanced = net(MachAddon.IsMachBalanced)
end)

--This hook will handle the auto balance feature

addHook("MapChange", AutoBalance)