--freeslots!
freeslot("sfx_mchjmp")
sfxinfo[sfx_mchjmp].caption = "Static Jump"

--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
local removeABar = MachAddon.removeABar
local JumpManager = MachAddon.JumpManager
//local FailVibeCheck = MachAddon.FailVibeCheck

--a function that spawns a single effect
local function spawnOneEffect(objColor, ...)
	local arg1, arg2, arg3, arg4, arg5 = ...
	local effect = P_SpawnMobjFromMobj(arg1, arg2, arg3, arg4, arg5)
	--local effect = P_SpawnMobjFromMobj(...)
	effect.colorized = true
	effect.frame = $ | FF_ADD
	effect.color = objColor
end

//another function reused from Emmette's wind jumps, makes effects setup easy
local function EffectSpawners(orimo, dist, effmo, player)
	local orimoHalfHeight = orimo.height / 2
	local invertDist = dist * -1
	local pColor = player.mo.color
	
	spawnOneEffect(pColor, orimo, dist, 0, orimoHalfHeight, effmo)
	spawnOneEffect(pColor, orimo, invertDist, 0, orimoHalfHeight, effmo)
	spawnOneEffect(pColor, orimo, 0, dist, orimoHalfHeight, effmo)
	spawnOneEffect(pColor, orimo, 0, invertDist, orimoHalfHeight, effmo)
end

local function StaticJumps(player)
	/*anything in abilityspecial or spinspecial hooks already don't execute
	if the player is in pain/in nightsmode or in any other condition we check
	for in FailVibeCheck*/
	if not MachSkinCheck(player)// or FailVibeCheck(player) then
		return	
	end
	
	local pmo = player.mo
	local pscale = pmo.scale
	
	if player.machvars.barsFilled > 0 then
		JumpManager(pmo, 10 * pscale)
		S_StartSound(pmo, sfx_mchjmp)
		S_StartSound(pmo, sfx_s3k45)
		EffectSpawners(pmo, 40 * pmo.scale, MT_SUPERSPARK, player)
		removeABar(player)
	elseif not player.machvars.weakjumped
		JumpManager(pmo, 6 * pscale)
		S_StartSound(pmo, sfx_mchjmp)
		EffectSpawners(pmo, 30 * pscale, MT_WATERZAP, player)
		pmo.momx = $ / 2
		pmo.momy = $ / 2
		player.machvars.weakjumped = true
	end
	return true
end

//hooks
addHook("AbilitySpecial", StaticJumps)