--Basically the math library

MachAddon.speedCalc = function(pmo) --this calculates a player's speed and returns it
	--Time to check speed and send it back!
	return FixedHypot(pmo.momx, FixedHypot(pmo.momy, pmo.momz))
end

//this function is reused from Emmette's wind jumps
MachAddon.JumpManager = function(mo, hight)
	/*this nerfs the jumps while underwater or in space so that the player 
	doesn't jump way higher underwater than on dry land*/
	if mo.eflags & MFE_UNDERWATER or mo.eflags & MFE_GOOWATER or 
			P_InSpaceSector(mo)
		hight = $ - ($ / 3)
	end
	P_SetObjectMomZ(mo, hight)
end

--this function handles the removal of charge
MachAddon.removeABar = function(p)
	--remove 200 charge if an ability is used.
	--This is how scarlet like it
	if MachAddon.IsMachBalanced == 2 then
		p.machvars.staticCharge = $ - 200
	else
	--balance mode mechanic only to satisfy Pikaspoop
	--using an ability with any energy above level 3 will drain that
	--plus the entire 3rd bar.
	--this is how Pika initally wanted the charge mechanic to work.
		local staticCharge = p.machvars.staticCharge
		if staticCharge > 600 then
			p.machvars.staticCharge = $ - (200 + (staticCharge % 600))
		else
			p.machvars.staticCharge = $ - 200
		end
	end
end