--This file holds the common checks that every script will use.
--They are stored in userdata, but loaded in local variables for each script.

//a function to make skinchecking easier
MachAddon.MachSkinCheck = function(player)
	if player.mo == nil
		return false
	elseif not player.mo.valid then
		return false
	elseif player.mo.skin ~= "mach"
		return false
	end
	return true
end

--This function changes Mach's state.
MachAddon.StateSetter = function(mo, sstate)
	if mo.state ~= sstate
		mo.state = sstate
	end
end

//gonna override the isplayerinnights function for the sake of optimization
MachAddon.IsPlayerInNights = function(player)
	return player.powers[pw_carry] == CR_NIGHTSMODE or 
			player.powers[pw_carry] == CR_NIGHTSFALL
end