--freeslots!
freeslot("sfx_mchspn")
sfxinfo[sfx_mchspn].caption = "Static Spin"

--The spin sound is defined in the skin soc

--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck
local StateSetter = MachAddon.StateSetter

local function SpindashExtra(player)
	/*anything in abilityspecial or spinspecial hooks already don't execute
	if the player is in pain/in nightsmode or in any other condition we check
	for in FailVibeCheck*/
	if not MachSkinCheck(player)// or FailVibeCheck(player) then
		return
	end
	
	local pmo = player.mo
	--If Mach is taunting, stop it and let him spindash!
	if player.machvars.mach_taunt == true then
		player.machvars.mach_taunt = false
		StateSetter(pmo, S_PLAY_SPINDASH)
	end
	
	--Time to play the spin sound!
	if player.machvars.isSpinning and not S_SoundPlaying(pmo, sfx_beelec)
		S_StartSound(pmo, sfx_beelec)
	end
	return
end

local function RollProperties(player)
	if not MachSkinCheck(player) or player.machvars.BadVibes then
		return
	end
	
	local pFlags = player.pflags/*changing this doesn't change the actual
	player's pflags, pika *facepalm*/
	local pmo = player.mo
	
	if player.machvars.spinPress and P_IsObjectOnGround(player.mo)
	and player.machvars.xplodetimer < 0 then		
		if (pFlags & PF_SPINNING) and player.machvars.isSpinning then
			player.machvars.isSpinning = false
			//pFlags = $ & ~PF_SPINNING
			player.pflags = $ & ~PF_SPINNING
			StateSetter(pmo, S_PLAY_WALK)
		else
			player.machvars.isSpinning = true
			//pFlags = $ | PF_SPINNING
			player.pflags = $ | PF_SPINNING
			//StateSetter(pmo, S_PLAY_ROLL)
		end
	end
	
	--this sets the spinning playervar to false if mach isn't spinning
	if player.machvars.isSpinning and not ((pFlags & PF_SPINNING) or pmo.state == S_PLAY_ROLL) then
		player.machvars.isSpinning = false
	end
	
	//this handles the particles and control while spinning
	if P_IsObjectOnGround(pmo) and (pFlags & PF_SPINNING) then
			
		if pmo.state == S_PLAY_ROLL then
		--We're rolling, remove charge and show some VFX
			player.machvars.staticCharge = $ - 2
			local rolleffect = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_WATERZAP)
			rolleffect.colorized = true
			rolleffect.frame = $ | FF_ADD
			rolleffect.color = player.skincolor
		elseif pmo.state == S_PLAY_SPINDASH and player.machvars.barsFilled < 3 then
		--We're spincharging, increase charge quickly!!!
			player.machvars.staticCharge = $ + 5
		end
	end
end

//hooks
addHook("SpinSpecial", SpindashExtra)

addHook("PlayerThink", RollProperties)