--load required functions from the Lib fodler
local MachSkinCheck = MachAddon.MachSkinCheck

--Simple function to make a flag true for 1 tic on each spin press.
--spinPress is the flag used in other scripts for spin presses
--spinControlFlag should only ever be used here, it allows the toggle to work.
local function spinPress(p)
	if not MachSkinCheck(p) then
		return false
	end
	
	if (p.cmd.buttons & BT_SPIN) then
		if p.machvars.spinControlFlag then
			p.machvars.spinPress = false
		else
			p.machvars.spinPress = true
			p.machvars.spinControlFlag = true
		end
	else
		if p.machvars.spinControlFlag then
			p.machvars.spinPress = false
			p.machvars.spinControlFlag = false
		end
	end
	return true
end


--hooks
addHook("PlayerThink", spinPress)