print("=== Mach is currently Loading! ===")

--simple command to load files from folders
local path = ""
local loadPath = function(file)
	dofile(path .. "/" .. file)
end

--Set namespace to MachAddon
rawset(_G, "MachAddon", {})

--start loading lua

path = "Lib"
loadPath("LogicChecks.lua")
loadPath("Calculatons.lua")

path = "Console"
loadPath("BalanceMode.lua")

path = "Passive"
loadPath("ControlPVars.lua")
loadPath("CarryDropFix.lua")
loadPath("TouchGrass.lua")
loadPath("ButtonPress.lua")
loadPath("RingAttraction.lua")

path = "Hud"
loadPath("Hud.lua")

path = "Effects"
loadPath("ParticlesAndEffects.lua")

path = "Charge"
loadPath("ChargeMechanic.lua")
loadPath("Overcharge.lua")
loadPath("DamageChecks.lua")
loadPath("ShieldDrain.lua")

path = "Spin"
loadPath("ChargeThok.lua")
loadPath("Spindash.lua")

path = "Jump"
loadPath("StaticJumps.lua")

path = "FunnyShit"
loadPath("StupidAssTaunt.lua")

--not running this again, may as well clean up the variables and function
path = nil
loadPath = nil

print("=== Mach has successfully loaded! ===")